Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/src/Parameters_msg_error.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/src/Parameters_msg_error.cpp	(revision 137)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/src/Parameters_msg_error.cpp	(revision 138)
@@ -24,6 +24,5 @@
     Parameters_test test ("Core");
 
-    // TESTER SI LES VALEURS NE DEPASSE PAS DE L'INTERVALLE AUTORISE
-
+    // Test if value is valid
     {
       // initialisation
@@ -191,4 +190,6 @@
           uint32_t num_execute_loop = _link_execute_unit_with_load_store_unit [i].first;
           uint32_t num_execute_unit = _link_execute_unit_with_load_store_unit [i].second;
+
+          log_printf(TRACE,Core,FUNCTION,"  * _link_execute_unit_with_load_store_unit  [%d] = %d.%d",i,num_execute_loop,num_execute_unit);
 
           nb_link_execute_unit [num_execute_loop][num_execute_unit] ++;
@@ -224,69 +225,36 @@
     
     {
-      // initialisation
-      uint32_t nb_link_slot      [_nb_ooo_engine][max<uint32_t>(_nb_inst_issue_slot,_nb_ooo_engine)];
-      uint32_t nb_link_read_bloc [_nb_read_bloc];
-  
-      // initialisation
-      for (uint32_t i=0; i<_nb_ooo_engine; ++i)
-        for (uint32_t j=0; j<_nb_inst_issue_slot[i]; ++j)
-          nb_link_slot [i][j] = 0;
+      bool     read_bloc_link_with_load_store_unit  [_nb_read_bloc];
+      bool     read_bloc_link_with_functionnal_unit [_nb_read_bloc];
+      uint32_t nb_link_functionnal_unit [_nb_functionnal_unit];
+      
       for (uint32_t i=0; i<_nb_read_bloc; ++i)
-        nb_link_read_bloc [i] = 0;
-
-      // set link
-      for (uint32_t i=0; i<_nb_ooo_engine; ++i)
-        for (uint32_t j=0; j<_nb_inst_issue_slot[i]; ++j)
-          for (uint32_t k=0; k<_nb_read_bloc; ++k)
-            if (_table_dispatch [i][j][k])
-              {
-                nb_link_slot      [i][j] ++;
-                nb_link_read_bloc [k] ++;
-              }
-      
-      // test
-      for (uint32_t i=0; i<_nb_ooo_engine; ++i)
-        for (uint32_t j=0; j<_nb_inst_issue_slot[i]; ++j)
-          if (nb_link_slot [i][j] == 0)
-            test.error(toString(_("In Out Of Order Engine [%d], the slot issue [%d] is not link with a read_bloc.\n"),i,j));
+        {
+          read_bloc_link_with_load_store_unit  [i] = false;
+          read_bloc_link_with_functionnal_unit [i] = false;
+        }
+      for (uint32_t i=0; i<_nb_functionnal_unit; ++i)
+        nb_link_functionnal_unit [i] = 0;
+      
+      for (uint32_t i=0; i<_nb_load_store_unit; ++i)
+        read_bloc_link_with_load_store_unit [_link_read_bloc_with_load_store_unit[i]] = true;
+      
       for (uint32_t i=0; i<_nb_read_bloc; ++i)
-        if (nb_link_read_bloc [i] == 0)
-          test.error(toString(_("Read_bloc [%d] is not link with a issue's slot.\n"),i));
-    }
-
-    {
-      uint32_t nb_link_read_bloc        [_nb_read_bloc];
-      uint32_t nb_link_load_store_unit  [_nb_load_store_unit];
-      uint32_t nb_link_functionnal_unit [_nb_functionnal_unit];
+        for (uint32_t j=0; j<_nb_functionnal_unit; ++j)
+          if (_link_read_bloc_and_functionnal_unit [i][j])
+            {
+              nb_link_functionnal_unit [j] ++;
+              read_bloc_link_with_functionnal_unit [i] = true;
+            }
 
       for (uint32_t i=0; i<_nb_read_bloc; ++i)
-        nb_link_read_bloc [i] = 0;
-      for (uint32_t i=0; i<_nb_load_store_unit; ++i)
-        nb_link_load_store_unit [i] = 0;
-      for (uint32_t i=0; i<_nb_functionnal_unit; ++i)
-        nb_link_functionnal_unit [i] = 0;
-
-      for (uint32_t i=0; i<_nb_read_bloc; ++i)
-        {
-          for (uint32_t j=0; j<_nb_load_store_unit; ++j)
-            if (_link_read_bloc_and_load_store_unit [i][j])
-              {
-                nb_link_read_bloc        [i] ++;
-                nb_link_load_store_unit  [j] ++;
-              }
-          for (uint32_t j=0; j<_nb_functionnal_unit; ++j)
-            if (_link_read_bloc_and_functionnal_unit [i][j])
-              {
-                nb_link_read_bloc        [i] ++;
-                nb_link_functionnal_unit [j] ++;
-              }
-        }
-
-      for (uint32_t i=0; i<_nb_read_bloc; ++i)
-        if (nb_link_read_bloc [i] == 0)
-          test.error(toString(_("Read_bloc [%d] is not link with an execute_unit.\n"),i));
-      for (uint32_t i=0; i<_nb_load_store_unit; ++i)
-        if (nb_link_load_store_unit [i] == 0)
-          test.error(toString(_("load_store_unit [%d] is not link with a read_bloc.\n"),i));
+        {
+          if (not read_bloc_link_with_load_store_unit  [i] and
+              not read_bloc_link_with_functionnal_unit [i])
+            test.error(toString(_("Read_bloc [%d] is not link with an execute_unit.\n"),i));
+          if (    read_bloc_link_with_load_store_unit  [i] and
+                  read_bloc_link_with_functionnal_unit [i])
+            test.error(toString(_("Read_bloc [%d] is linked with an load store unit and functionnal unit.\n"),i));
+        }
       for (uint32_t i=0; i<_nb_functionnal_unit; ++i)
         if (nb_link_functionnal_unit [i] == 0)
@@ -296,36 +264,25 @@
     {
       uint32_t nb_link_write_bloc       [_nb_write_bloc];
-      uint32_t nb_link_load_store_unit  [_nb_load_store_unit];
       uint32_t nb_link_functionnal_unit [_nb_functionnal_unit];
 
       for (uint32_t i=0; i<_nb_write_bloc; ++i)
         nb_link_write_bloc [i] = 0;
-      for (uint32_t i=0; i<_nb_load_store_unit; ++i)
-        nb_link_load_store_unit [i] = 0;
       for (uint32_t i=0; i<_nb_functionnal_unit; ++i)
         nb_link_functionnal_unit [i] = 0;
 
+      for (uint32_t i=0; i<_nb_load_store_unit; ++i)
+        nb_link_write_bloc [_link_write_bloc_with_load_store_unit[i]] = true;
+
       for (uint32_t i=0; i<_nb_write_bloc; ++i)
-        {
-          for (uint32_t j=0; j<_nb_load_store_unit; ++j)
-            if (_link_write_bloc_and_load_store_unit [i][j])
-              {
-                nb_link_write_bloc       [i] ++;
-                nb_link_load_store_unit  [j] ++;
-              }
-          for (uint32_t j=0; j<_nb_functionnal_unit; ++j)
-            if (_link_write_bloc_and_functionnal_unit [i][j])
-              {
-                nb_link_write_bloc       [i] ++;
-                nb_link_functionnal_unit [j] ++;
-              }
-        }
+        for (uint32_t j=0; j<_nb_functionnal_unit; ++j)
+          if (_link_write_bloc_and_functionnal_unit [i][j])
+            {
+              nb_link_write_bloc       [i] ++;
+              nb_link_functionnal_unit [j] ++;
+            }
 
       for (uint32_t i=0; i<_nb_write_bloc; ++i)
         if (nb_link_write_bloc [i] == 0)
           test.error(toString(_("Write_bloc [%d] is not link with an execute_unit.\n"),i));
-      for (uint32_t i=0; i<_nb_load_store_unit; ++i)
-        if (nb_link_load_store_unit [i] == 0)
-          test.error(toString(_("load_store_unit [%d] is not link with a write_bloc.\n"),i));
       for (uint32_t i=0; i<_nb_functionnal_unit; ++i)
         if (nb_link_functionnal_unit [i] == 0)
@@ -334,7 +291,9 @@
 
     {
-      uint32_t nb_link_thread           [_nb_thread];
-      uint32_t nb_link_load_store_unit  [_nb_load_store_unit];
-      uint32_t nb_link_functionnal_unit [_nb_functionnal_unit];
+      uint32_t nb_link_thread                      [_nb_thread];
+      uint32_t nb_link_load_store_unit             [_nb_load_store_unit];
+      uint32_t nb_link_functionnal_unit            [_nb_functionnal_unit];
+      bool     link_front_end_with_execute_loop    [_nb_front_end][_nb_execute_loop];
+      uint32_t nb_link_front_end_with_execute_loop [_nb_front_end];
 
       for (uint32_t i=0; i<_nb_thread; ++i)
@@ -344,12 +303,25 @@
       for (uint32_t i=0; i<_nb_functionnal_unit; ++i)
         nb_link_functionnal_unit [i] = 0;
-      
-      for (uint32_t i=0; i<_nb_thread; ++i)
-        {
+      for (uint32_t i=0; i<_nb_front_end; ++i)
+        {
+          nb_link_front_end_with_execute_loop [i] = 0;
+          for (uint32_t j=0; j<_nb_execute_loop; ++j)
+            link_front_end_with_execute_loop [i][j] = false;
+        }
+
+      for (uint32_t i=0; i<_nb_thread; ++i)
+        {
+          uint32_t num_front_end = _link_context_with_thread [i].first;
+
           {
             uint32_t num_load_store_unit = _link_load_store_unit_with_thread [i];
+            uint32_t num_execute_loop    = _link_execute_unit_with_load_store_unit [i].first;
             
             nb_link_thread           [i] ++;
             nb_link_load_store_unit  [num_load_store_unit] ++;
+
+            if (not link_front_end_with_execute_loop [num_front_end][num_execute_loop])
+              nb_link_front_end_with_execute_loop [num_front_end] ++;
+            link_front_end_with_execute_loop [num_front_end][num_execute_loop] = true;
           }
 
@@ -357,6 +329,12 @@
             if (_link_thread_and_functionnal_unit [i][j])
               {
+                uint32_t num_execute_loop = _link_execute_unit_with_functionnal_unit [i].first;
+
                 nb_link_thread           [i] ++;
                 nb_link_functionnal_unit [j] ++;
+                
+                if (not link_front_end_with_execute_loop [num_front_end][num_execute_loop])
+                  nb_link_front_end_with_execute_loop [num_front_end] ++;
+                link_front_end_with_execute_loop [num_front_end][num_execute_loop] = true;
               }
         }
@@ -371,4 +349,7 @@
         if (nb_link_functionnal_unit [i] == 0)
           test.error(toString(_("Functionnal_unit [%d] is not link with a thread.\n"),i));
+      for (uint32_t i=0; i<_nb_front_end; ++i)
+        if (nb_link_front_end_with_execute_loop [i] != 1)
+          test.error(toString(_("Front end [%d] is link with many execute_loop.\n"),i));
     }
     
@@ -395,5 +376,5 @@
       for (uint32_t i=0; i<_nb_load_store_unit; ++i)
         for (uint32_t j=0; j<_nb_cache_port[i]; ++j)
-        nb_link_dcache_port [_link_dcache_port_with_load_store_unit[i][j]] ++;
+          nb_link_dcache_port [_link_dcache_port_with_load_store_unit[i][j]] ++;
       
       for (uint32_t i=0; i<_nb_dcache_port; ++i)
@@ -402,24 +383,4 @@
     }
 
-
-//   public : pair_dual             * _link_context_with_thread                      ;//[nb_thread]
-//   public : pair_dual             * _link_decod_unit_with_decod_bloc               ;//[nb_decod_bloc]
-//   public : pair_dual             * _link_rename_unit_with_rename_bloc             ;//[nb_rename_bloc]
-//   public : pair_dual             * _link_read_unit_with_read_bloc                 ;//[nb_read_bloc]
-//   public : pair_dual             * _link_write_unit_with_write_bloc               ;//[nb_write_bloc]
-//   public : pair_dual             * _link_execute_unit_with_functionnal_unit       ;//[nb_functionnal_unit]
-//   public : pair_dual             * _link_execute_unit_with_load_store_unit        ;//[nb_load_store_unit]
-//   public : uint32_t              * _link_decod_bloc_with_thread                   ;//[nb_thread]
-//   public : uint32_t              * _link_rename_bloc_with_front_end               ;//[nb_front_end]
-//   public : bool                *** _table_dispatch                                ;//[nb_ooo_engine][nb_inst_issue][nb_read_bloc]
-//   public : bool                 ** _link_read_bloc_and_load_store_unit            ;//[nb_read_bloc][nb_load_store_unit]
-//   public : bool                 ** _link_read_bloc_and_functionnal_unit           ;//[nb_read_bloc][nb_functionnal_unit]
-//   public : bool                 ** _link_write_bloc_and_load_store_unit           ;//[nb_write_bloc][nb_load_store_unit]
-//   public : bool                 ** _link_write_bloc_and_functionnal_unit          ;//[nb_write_bloc][nb_functionnal_unit]
-//   public : uint32_t              * _link_load_store_unit_with_thread              ;//[nb_thread]
-//   public : bool                 ** _link_thread_and_functionnal_unit              ;//[nb_thread][nb_functionnal_unit]
-//   public : uint32_t              * _link_icache_port_with_thread                  ;//[nb_thread]
-//   public : uint32_t             ** _link_dcache_port_with_load_store_unit         ;//[nb_load_store_unit][nb_cache_port]
-
     log_end(Core,FUNCTION);
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/src/Parameters_print.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/src/Parameters_print.cpp	(revision 137)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/src/Parameters_print.cpp	(revision 138)
@@ -176,5 +176,4 @@
     str+= toString(MSG_INFORMATION)+"     * nb_rename_unit                              : "+toString<uint32_t         >(_nb_rename_unit          [i])+"\n";
     str+= toString(MSG_INFORMATION)+"     * nb_inst_issue_queue                         : "+toString<uint32_t         >(_nb_inst_issue_queue     [i])+"\n";
-    str+= toString(MSG_INFORMATION)+"     * nb_inst_issue_slot                          : "+toString<uint32_t         >(_nb_inst_issue_slot      [i])+"\n";
     str+= toString(MSG_INFORMATION)+"     * nb_inst_reexecute                           : "+toString<uint32_t         >(_nb_inst_reexecute       [i])+"\n";
     str+= toString(MSG_INFORMATION)+"     * nb_inst_commit                              : "+toString<uint32_t         >(_nb_inst_commit          [i])+"\n";
@@ -193,6 +192,4 @@
     str+= toString(MSG_INFORMATION)+"     * issue_load_balancing                        : "+toString<Tload_balancing_t>(_issue_load_balancing    [i])+"\n";
     str+= toString(MSG_INFORMATION)+"     * size_reexecute_queue                        : "+toString<uint32_t         >(_size_reexecute_queue    [i])+"\n";
-    str+= toString(MSG_INFORMATION)+"     * reexecute_priority                          : "+toString<Tpriority_t      >(_reexecute_priority      [i])+"\n";
-    str+= toString(MSG_INFORMATION)+"     * reexecute_load_balancing                    : "+toString<Tload_balancing_t>(_reexecute_load_balancing[i])+"\n";
       }
 
@@ -245,13 +242,11 @@
 
     
-    for (uint32_t i=0; i<_nb_read_bloc; ++i)
-      for (uint32_t j=0; j<_nb_load_store_unit; ++j)
-    str+= toString(MSG_INFORMATION)+"   * link_read_bloc_and_load_store_unit              ["+toString(i)+"]["+toString(j)+"] : "+toString(_link_read_bloc_and_load_store_unit  [i][j])+"\n";//[nb_read_bloc][nb_load_store_unit]
+    for (uint32_t i=0; i<_nb_load_store_unit; ++i)
+    str+= toString(MSG_INFORMATION)+"   * link_read_bloc_with_load_store_unit             ["+toString(i)+"] : "+toString(_link_read_bloc_with_load_store_unit  [i])+"\n";//[nb_load_store_unit]
     for (uint32_t i=0; i<_nb_read_bloc; ++i)
       for (uint32_t j=0; j<_nb_functionnal_unit; ++j)
     str+= toString(MSG_INFORMATION)+"   * link_read_bloc_and_functionnal_unit             ["+toString(i)+"]["+toString(j)+"] : "+toString(_link_read_bloc_and_functionnal_unit [i][j])+"\n";//[nb_read_bloc][nb_functionnal_unit]
-    for (uint32_t i=0; i<_nb_write_bloc; ++i)
-      for (uint32_t j=0; j<_nb_load_store_unit; ++j)
-    str+= toString(MSG_INFORMATION)+"   * link_write_bloc_and_load_store_unit             ["+toString(i)+"]["+toString(j)+"] : "+toString(_link_write_bloc_and_load_store_unit [i][j])+"\n";//[nb_write_bloc][nb_load_store_unit]
+    for (uint32_t i=0; i<_nb_load_store_unit; ++i)
+    str+= toString(MSG_INFORMATION)+"   * link_write_bloc_with_load_store_unit            ["+toString(i)+"] : "+toString(_link_write_bloc_with_load_store_unit [i])+"\n";//[nb_load_store_unit]
     for (uint32_t i=0; i<_nb_write_bloc; ++i)
       for (uint32_t j=0; j<_nb_functionnal_unit; ++j)
@@ -262,10 +257,4 @@
 
     str+= toString(MSG_INFORMATION)+" -----[ Dispatch ]---------------------------------\n";
-
-    for (uint32_t i=0; i<_nb_ooo_engine; ++i)
-      for (uint32_t j=0; j<_nb_inst_issue_slot[i]; ++j)
-        for (uint32_t k=0; k<_nb_read_bloc; ++k)
-    str+= toString(MSG_INFORMATION)+"   * table_dispatch                                  ["+toString(i)+"]["+toString(j)+"]["+toString(k)+"] : "+toString(_table_dispatch                      [i][j][k])+"\n";//[nb_ooo_engine][nb_inst_issue][nb_read_bloc]
-
     str+= toString(MSG_INFORMATION)+"   * dispatch_priority                             : "+toString<Tpriority_t      >(_dispatch_priority      )+"\n";
     str+= toString(MSG_INFORMATION)+"   * dispatch_load_balancing                       : "+toString<Tload_balancing_t>(_dispatch_load_balancing);
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/include/RegisterFile_Monolithic.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/include/RegisterFile_Monolithic.h	(revision 137)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/include/RegisterFile_Monolithic.h	(revision 138)
@@ -50,6 +50,9 @@
   public    : Stat                           * _stat;
     
-  private   : counter_t                      * _stat_nb_read;
-  private   : counter_t                      * _stat_nb_write;
+  // private   : counter_t                      * _stat_nb_read;
+  // private   : counter_t                      * _stat_nb_write;
+  private   : counters_t                     * _stat_port_read;
+  private   : counters_t                     * _stat_port_write;
+  private   : counters_t                     * _stat_port_read_write;
 #endif
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/src/RegisterFile_Monolithic_statistics_declaration.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/src/RegisterFile_Monolithic_statistics_declaration.cpp	(revision 137)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/src/RegisterFile_Monolithic_statistics_declaration.cpp	(revision 138)
@@ -21,12 +21,32 @@
 		      param_statistics);
 
-    _stat_nb_read           = _stat->create_variable("nb_read" );
-    _stat_nb_write          = _stat->create_variable("nb_write");
+    if (_param->_nb_port_read>0)
+    _stat_port_read         = _stat->create_counters("port_read",_param->_nb_port_read,"",
+                                                     _("Usage of read port %d."),
+                                                     _("Percent of usage read port %d."),
+                                                     _("Average of usage read port.")
+                                                     );
 
-    _stat->create_expr_average_by_cycle("average_read" , "nb_read" , "", _("Average read by cycle" ));
-    _stat->create_expr_average_by_cycle("average_write", "nb_write", "", _("Average write by cycle"));
+    if (_param->_nb_port_write>0)
+    _stat_port_write        = _stat->create_counters("port_write",_param->_nb_port_write,"",
+                                                     _("Usage of write port %d."),
+                                                     _("Percent of usage write port %d."),
+                                                     _("Average of usage write port.")
+                                                     );
+    if (_param->_nb_port_read_write>0)
+    _stat_port_read_write   = _stat->create_counters("port_read_write",_param->_nb_port_read_write,"",
+                                                     _("Usage of read_write port."),
+                                                     _("Percent of usage read_write port %d."),
+                                                     _("Average of usage read_write port.")
+                                                     );
 
-    _stat->create_expr_percent         ("percent_use_read" , "average_read" , toString(_param->_nb_port_read +_param->_nb_port_read_write), _("Percent read by cycle" ));
-    _stat->create_expr_percent         ("percent_use_write", "average_write", toString(_param->_nb_port_write+_param->_nb_port_read_write), _("Percent write by cycle"));
+    // _stat_nb_read           = _stat->create_variable("nb_read" );
+    // _stat_nb_write          = _stat->create_variable("nb_write");
+
+    // _stat->create_expr_average_by_cycle("average_read" , "nb_read" , "", _("Average read by cycle" ));
+    // _stat->create_expr_average_by_cycle("average_write", "nb_write", "", _("Average write by cycle"));
+
+    // _stat->create_expr_percent         ("percent_use_read" , "average_read" , toString(_param->_nb_port_read +_param->_nb_port_read_write), _("Percent read by cycle" ));
+    // _stat->create_expr_percent         ("percent_use_write", "average_write", toString(_param->_nb_port_write+_param->_nb_port_read_write), _("Percent write by cycle"));
 
   };
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/src/RegisterFile_Monolithic_transition.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/src/RegisterFile_Monolithic_transition.cpp	(revision 137)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/src/RegisterFile_Monolithic_transition.cpp	(revision 138)
@@ -37,4 +37,9 @@
     else
       {
+#ifdef STATISTICS
+        uint32_t stat_nb_read      =0;
+        uint32_t stat_nb_write     =0;
+        uint32_t stat_nb_read_write=0;
+#endif
         for (uint32_t i=0; i<_param->_nb_port_write; i++)
           {
@@ -45,7 +50,11 @@
               {
 #ifdef STATISTICS
-                if (usage_is_set(_usage,USE_STATISTICS))
-                  (*_stat_nb_write) ++;
-#endif    
+                stat_nb_write++;
+#endif
+
+// #ifdef STATISTICS
+//                 if (usage_is_set(_usage,USE_STATISTICS))
+//                   (*_stat_nb_write) ++;
+// #endif    
 
                 Taddress_t address = (_param->_have_port_address)?PORT_READ(in_WRITE_ADDRESS[i]):0;
@@ -74,10 +83,14 @@
             if (PORT_READ(in_READ_WRITE_VAL[i]) == true)
               {
+#ifdef STATISTICS
+                stat_nb_read_write++;
+#endif
+
                 if (PORT_READ(in_READ_WRITE_RW [i]) == RW_WRITE)
                   {
-#ifdef STATISTICS
-                    if (usage_is_set(_usage,USE_STATISTICS))
-                      (*_stat_nb_write) ++;
-#endif    
+// #ifdef STATISTICS
+//                     if (usage_is_set(_usage,USE_STATISTICS))
+//                       (*_stat_nb_write) ++;
+// #endif    
                     
                     Taddress_t address = (_param->_have_port_address)?PORT_READ(in_READ_WRITE_ADDRESS[i]):0;
@@ -95,21 +108,34 @@
                     reg_DATA[address] = data;
                   }
-#ifdef STATISTICS
-                else
-                  {
-                    if (usage_is_set(_usage,USE_STATISTICS))
-                      (*_stat_nb_read) ++;
-                  }
-#endif    
+// #ifdef STATISTICS
+//                 else
+//                   {
+//                     if (usage_is_set(_usage,USE_STATISTICS))
+//                       (*_stat_nb_read) ++;
+//                   }
+// #endif    
               }
           }
+
+        
+#ifdef STATISTICS
+        if (usage_is_set(_usage,USE_STATISTICS))
+          {
+            for (uint32_t i=0; i<_param->_nb_port_read; i++)
+              if ( PORT_READ(in_READ_VAL [i]) == 1)
+                {
+                  stat_nb_read ++;
+                  // (*_stat_nb_read) ++;
+                }
+
+            if (_param->_nb_port_read>0)
+            (*_stat_port_read      ) += stat_nb_read;
+            if (_param->_nb_port_write>0)
+            (*_stat_port_write     ) += stat_nb_write;
+            if (_param->_nb_port_read_write>0)
+            (*_stat_port_read_write) += stat_nb_read_write;
+          }
+#endif    
       }
-
-#ifdef STATISTICS
-    if (usage_is_set(_usage,USE_STATISTICS))
-      for (uint32_t i=0; i<_param->_nb_port_read; i++)
-        if ( PORT_READ(in_READ_VAL [i]) == 1)
-          (*_stat_nb_read) ++;
-#endif    
 
 #if defined(DEBUG_RegisterFile_Monolithic) and DEBUG_RegisterFile_Monolithic and (DEBUG >= DEBUG_TRACE)
